import { DynamicModule } from '@nestjs/common';
import { ConfigProvider } from './types';
import { DotenvConfigOptions } from 'dotenv';
import { IConfigModuleOptions } from './interfaces';
export declare class ConfigModule {
    /**
     * @param path
     */
    static resolveRootPath(path: string): ConfigModule;
    /**
     * @param config
     * @param options
     */
    static forRoot(config: ConfigProvider, options?: DotenvConfigOptions): DynamicModule;
    /**
     * @param options
     */
    static forRootAsync(options: string | IConfigModuleOptions): Promise<DynamicModule>;
    /**
     * @param conifg
     * @param options
     */
    forRoot(conifg: ConfigProvider, options?: DotenvConfigOptions): DynamicModule;
    /**
     * @param options
     */
    forRootAsync(options: string | IConfigModuleOptions): Promise<DynamicModule>;
}
