"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var ConfigModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const config_service_1 = require("./config.service");
const utils_1 = require("./utils");
let ConfigModule = ConfigModule_1 = class ConfigModule {
    /**
     * @param path
     */
    static resolveRootPath(path) {
        config_service_1.ConfigService.resolveRootPath(path);
        return ConfigModule_1;
    }
    /**
     * @param config
     * @param options
     */
    static forRoot(config, options) {
        config_service_1.ConfigService.loadDotEnv(options);
        const configProvider = utils_1.createProvider(config, '');
        const providers = [configProvider, config_service_1.ConfigService];
        config_service_1.ConfigService.setReference(typeof configProvider.provide === 'function' ? configProvider.provide['prototype'] : configProvider.provide, 'default');
        return {
            module: ConfigModule_1,
            providers,
            exports: providers,
        };
    }
    /**
     * @param options
     */
    static forRootAsync(options) {
        return __awaiter(this, void 0, void 0, function* () {
            config_service_1.ConfigService.loadDotEnv(typeof options === 'object' ? options.dotenv : undefined);
            const providers = yield config_service_1.ConfigService.createProviders(typeof options === 'object' ? options.glob : options);
            providers.push(config_service_1.ConfigService);
            return {
                module: ConfigModule_1,
                providers,
                exports: providers,
            };
        });
    }
    /**
     * @param conifg
     * @param options
     */
    forRoot(conifg, options) {
        return ConfigModule_1.forRoot(conifg, options);
    }
    /**
     * @param options
     */
    forRootAsync(options) {
        return __awaiter(this, void 0, void 0, function* () {
            return ConfigModule_1.forRootAsync(options);
        });
    }
};
ConfigModule = ConfigModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        providers: [config_service_1.ConfigService],
    })
], ConfigModule);
exports.ConfigModule = ConfigModule;
