import { Provider, Type } from '@nestjs/common';
import { ModuleRef } from '@nestjs/core';
import { DotenvConfigOptions } from 'dotenv';
import { ConfigProvider } from './types';
export declare class ConfigService {
    private readonly moduleRef;
    protected static rootPath?: string;
    protected static tokenReferences: {
        [s: string]: string | symbol | Type<any>;
    };
    protected static mode: 'sync' | 'async';
    protected static dotenvOptions: {};
    /**
     * @param moduleRef
     */
    constructor(moduleRef: ModuleRef);
    /**
     * @param options
     */
    static loadDotEnv(options?: DotenvConfigOptions | false): void;
    /**
     * @param dir
     */
    static root(dir?: string): string;
    /**
     * @param dir
     */
    static resolveRootPath(dir: string): typeof ConfigService;
    /**
     * @param glob
     */
    static getConfigFiles(glob: string): Promise<string[]>;
    /**
     * @param glob
     */
    static createProviders(glob: string): Promise<Provider[]>;
    /**
     * @param file
     */
    static loadFile(file: string): Provider;
    /**
     * @param token
     */
    protected findConfigProvider(token: string | symbol | Type<any>): ConfigProvider | null;
    /**
     * @param name
     */
    protected resolveTokenFromName(name: string): string | symbol | Type<any>;
    /**
     * @param name
     */
    has(name: string): boolean;
    /**
     * @param name
     * @param token
     */
    static setReference(name: string, token: string | symbol | Type<any>): typeof ConfigService;
    /**
     * @param pattern
     */
    protected getNameAndAshPatternFromPattern(pattern: string): [string, string];
    /**
     * @param pattern
     * @param value
     */
    get<T>(pattern: string, value?: any): T | undefined;
}
