"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @param {string} propertyName
 * @returns {<T extends {new(...args: any[]): {}}>(constructor: T) => {new(...args: any[]): {}; prototype: {}}}
 * @constructor
 */
exports.ProxyProperty = (propertyName) => function classDecorator(constructor) {
    return class extends constructor {
        constructor(...args) {
            super(...args);
            return new Proxy(this, {
                get: (target, prop) => {
                    if (target[prop] !== undefined) {
                        return target[prop];
                    }
                    else if (target[propertyName].hasOwnProperty(prop)) {
                        return target[propertyName][prop];
                    }
                },
            });
        }
    };
};
