"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_token_1 = require("./config.token");
const config_1 = require("../config");
const path = require("path");
function createProvider(configProvider, wholePath) {
    const fileName = path.basename(wholePath, '.' + wholePath.split('.').pop());
    const provide = configProvider['prototype'] !== undefined &&
        typeof configProvider !== 'object'
        ? configProvider
        : config_token_1.configToken(configProvider.__provide
            ? configProvider.__provide
            : configProvider.__name
                ? configProvider.__name
                : fileName);
    return isDynamicConfigProvider(configProvider)
        ? {
            provide,
            useClass: configProvider,
        }
        : {
            provide,
            useValue: new config_1.Config(configProvider),
        };
}
exports.createProvider = createProvider;
function isDynamicConfigProvider(configProvider) {
    return configProvider instanceof Function;
}
exports.isDynamicConfigProvider = isDynamicConfigProvider;
